diff -pruN 1:0.22.1-2/debian/changelog 1:0.23.0-1/debian/changelog
--- 1:0.22.1-2/debian/changelog	2020-09-15 08:54:27.000000000 +0000
+++ 1:0.23.0-1/debian/changelog	2020-11-24 13:06:33.000000000 +0000
@@ -1,3 +1,10 @@
+cffi (1:0.23.0-1) unstable; urgency=medium
+
+  * New upstream release
+  * Bump S-V to 4.5.1
+
+ -- Sébastien Villemot <sebastien@debian.org>  Tue, 24 Nov 2020 14:06:33 +0100
+
 cffi (1:0.22.1-2) unstable; urgency=medium
 
   * Add Depends on cl-rt for ecl autopkgtest. Since ecl 20.4.24, the rt
diff -pruN 1:0.22.1-2/debian/control 1:0.23.0-1/debian/control
--- 1:0.22.1-2/debian/control	2020-07-04 07:55:57.000000000 +0000
+++ 1:0.23.0-1/debian/control	2020-11-24 13:06:28.000000000 +0000
@@ -11,7 +11,7 @@ Build-Depends: debhelper-compat (= 13),
                texlive-extra-utils,
                texlive,
                texlive-plain-generic
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/common-lisp-team/cffi
 Vcs-Git: https://salsa.debian.org/common-lisp-team/cffi.git
 Homepage: https://common-lisp.net/project/cffi/
diff -pruN 1:0.22.1-2/doc/cffi-manual.texinfo 1:0.23.0-1/doc/cffi-manual.texinfo
--- 1:0.22.1-2/doc/cffi-manual.texinfo	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/doc/cffi-manual.texinfo	2020-07-08 11:38:29.000000000 +0000
@@ -2526,7 +2526,7 @@ CFFI-USER> (code-char (mem-aref * :char
 @Macro{defbitfield name-and-options &body masks}
 
 masks ::= [docstring] @{ (symbol value) @}* @*
-name-and-options ::= name | (name &optional (base-type :int))
+name-and-options ::= name | (name &optional (base-type :int)) @*
 
 @subheading Arguments and Values
 
@@ -2610,8 +2610,7 @@ CFFI> (unix-open "/tmp/foo" '(:wronly :c
 @subheading Syntax
 @Macro{defcstruct name-and-options &body doc-and-slots @res{} name}
 
-name-and-options ::= structure-name | (structure-name &key size)
-
+name-and-options ::= structure-name | (structure-name &key size) @*
 doc-and-slots ::= [docstring] @{ (slot-name slot-type &key count offset) @}*
 
 @subheading Arguments and Values
@@ -2820,8 +2819,8 @@ you should use @ref{define-foreign-type}
 @subheading Syntax
 @Macro{defcenum name-and-options &body enum-list}
 
-enum-list ::= [docstring] @{ keyword | (keyword value) @}*
-name-and-options ::= name | (name &optional (base-type :int) &key allow-undeclared-values)
+enum-list ::= [docstring] @{ keyword | (keyword value) @}* @*
+name-and-options ::= name | (name &optional (base-type :int) &key allow-undeclared-values) @*
 
 @subheading Arguments and Values
 
@@ -4661,7 +4660,7 @@ CFFI> (pointer-eq (null-pointer) (null-p
 @anchor{with-foreign-objects}
 @Macro{with-foreign-objects (bindings) &body body}
 
-bindings ::= @{(var type &optional count)@}*
+bindings ::= @{(var type &optional count)@}* @*
 
 @subheading Arguments and Values
 
@@ -5032,7 +5031,7 @@ CFFI> (with-foreign-pointer-as-string (s
 @anchor{with-foreign-strings}
 @Macro{with-foreign-strings (bindings) &body body}
 
-var-or-vars ::= var | (var &optional octet-size-var)
+var-or-vars ::= var | (var &optional octet-size-var) @*
 bindings ::= @{(var-or-vars string &rest args)@}*
 
 @subheading Arguments and Values
@@ -5135,7 +5134,7 @@ Dictionary
 @Macro{defcvar name-and-options type &optional documentation @res{} lisp-name}
 
 @var{name-and-options} ::= name | (name &key read-only (library :default)) @*
-@var{name} ::= lisp-name [foreign-name] | foreign-name [lisp-name]
+@var{name} ::= lisp-name [foreign-name] | foreign-name [lisp-name] @*
 
 @subheading Arguments and Values
 
@@ -6062,8 +6061,8 @@ CFFI> (let ((lib (load-foreign-library '
 
 @Macro{define-foreign-library name-and-options @{ load-clause @}* @res{} name}
 
-name-and-options ::= name | (name &key convention search-path)
-load-clause ::= (feature library &key convention search-path)
+name-and-options ::= name | (name &key canary convention search-path) @*
+load-clause ::= (feature library &key convention search-path) @*
 
 @subheading Arguments and Values
 
@@ -6077,6 +6076,15 @@ A feature expression.
 @item library
 A library designator.
 
+@item canary
+A string denoting a foreign symbol that will be searched in core
+before attempting to load the library. If that symbol is found, the
+library is assumed to be statically linked and
+@code{load-foreign-library} only marks the library as loaded.
+
+Some implementations (Clisp, ECL, SBCL) natively support static
+linking, sometimes referred to as a @emph{link kit}.
+
 @item convention
 One of @code{:cdecl} (default) or @code{:stdcall}
 
@@ -6486,8 +6494,8 @@ CFFI> (callback sum)
 @subheading Syntax
 @Macro{defcallback name-and-options return-type arguments &body body @res{} name}
 
-name-and-options ::= name | (name &key convention)
-arguments ::= (@{ (arg-name arg-type) @}*)
+name-and-options ::= name | (name &key convention) @*
+arguments ::= (@{ (arg-name arg-type) @}*) @*
 
 @subheading Arguments and Values
 
@@ -6983,13 +6991,21 @@ invocation.
 @node Static Linking, Limitations, The Groveller, Top
 @chapter Static Linking
 
-On recent enough versions of supported implementations (currently,
-GNU CLISP 2.49, CMUCL 2015-11, and SBCL 1.2.17), and with a recent
-enough ASDF (3.1.2 or later), you can create a statically linked
-Lisp executable image that includes all the C extensions
-(wrappers and any other objects output by @code{compile-op})
-as well as your Lisp code --- or a standalone application executable.
-This makes it easier to deliver your code as a single file.
+On recent enough versions of supported implementations (currently, GNU
+CLISP 2.49 or later, CMUCL 2015-11 or later, and SBCL 1.2.17 or later,
+except SBCL 2.0.4), and with a recent enough ASDF (3.1.2 or later),
+you can create a statically linked Lisp executable image (or a
+standalone application executable) that includes all the C extensions
+defined via @ref{The Groveller}'s @code{:cffi-wrapper-file} ASDF
+components (and any other such objects output by
+@code{asdf:compile-op}), as well as those defined by @code{:c-file} or
+@code{:o-file} ASDF components, and your Lisp code.  This makes it
+easier to deliver your code as a single file.
+
+Note that the resulting binary will typically still depend on any
+shared libraries loaded via @xref{load-foreign-library} or
+@xref{use-foreign-library} as well as core libraries such as
+@code{libc}.
 
 To dump a statically linked executable image, use:
 
diff -pruN 1:0.22.1-2/grovel/common.h 1:0.23.0-1/grovel/common.h
--- 1:0.22.1-2/grovel/common.h	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/grovel/common.h	2020-07-08 11:38:29.000000000 +0000
@@ -3,6 +3,7 @@
 #include <stdint.h>
 #include <string.h>
 #include <inttypes.h>
+#include <stddef.h>
 
 #ifndef offsetof
 #define offsetof(type, slot) ((long) ((char *) &(((type *) 0)->slot)))
diff -pruN 1:0.22.1-2/README.md 1:0.23.0-1/README.md
--- 1:0.22.1-2/README.md	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/README.md	2020-07-08 11:38:29.000000000 +0000
@@ -23,5 +23,8 @@ please see [these]((https://github.com/h
 Please consult [the manual][1] for further details, including
 installation instructions.
 
+Please visit [Launchpad][3] for bug reports and feature suggestions.
+
 [1]: http://common-lisp.net/project/cffi/manual/html_node/
 [2]: https://github.com/rpav/c2ffi
+[3]: http://bugs.launchpad.net/cffi
diff -pruN 1:0.22.1-2/src/c2ffi/generator.lisp 1:0.23.0-1/src/c2ffi/generator.lisp
--- 1:0.22.1-2/src/c2ffi/generator.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/src/c2ffi/generator.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -535,9 +535,9 @@ target package."
     (@ include-definitions)
     (@ exclude-definitions))
   (with-standard-io-syntax
-    (with-input-from-file (in c2ffi-spec-file :external-format (asdf/driver:encoding-external-format :utf-8))
+    (with-input-from-file (in c2ffi-spec-file :external-format (uiop:encoding-external-format :utf-8))
       (with-output-to-file (*c2ffi-output-stream* output :if-exists :supersede
-                            :external-format (asdf/driver:encoding-external-format output-encoding))
+                            :external-format (uiop:encoding-external-format output-encoding))
         (let* ((*package* (or (find-package package-name)
                               (make-package package-name)))
                ;; Make sure we use an uninterned symbol, so that it's neutral to READTABLE-CASE.
diff -pruN 1:0.22.1-2/src/cffi-abcl.lisp 1:0.23.0-1/src/cffi-abcl.lisp
--- 1:0.22.1-2/src/cffi-abcl.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/src/cffi-abcl.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -69,8 +69,6 @@
    #:native-namestring
    #:%mem-ref
    #:%mem-set
-   ;; #:make-shareable-byte-vector
-   ;; #:with-pointer-to-vector-data
    #:%foreign-symbol-pointer
    #:%defcallback
    #:%callback
@@ -291,10 +289,55 @@ supplied, it will be bound to SIZE durin
     (:pointer "getPointer")
     ((:short :unsigned-short) "getShort")))
 
+;;; HACK for now: keep track of all the pointers to malloc()'d memory
+;;; hashed by the shareable byte vectors we allocate.
+(defvar *static-vector-pointer*
+  (make-hash-table :weakness :value))
+
+;;; available in abcl-1.7.0
+;;; presence of :nio-buffer keyword to CL:MAKE-ARRAY
+#+nio
+(defun make-shareable-vector (length &key (element-type '(unsigned-byte 8)))
+  "Use memory on the heap for storing a vector of LENGTH with ELEMENT-TYPE
+
+Returns the allocated vector as the first value, and the pointer to
+the heap memory as the second.
+
+Only works for 8, 16, 32 bit bytes.
+"
+  (let* ((type
+           (first element-type))
+         (bits-per-byte
+           (second element-type))
+         (bytes-per-element  ;; ehh, not going to work well for element type not of size 8, 16, or 32
+           (ceiling bits-per-byte 8)))
+    (unless (subtypep element-type
+                      '(or (unsigned-byte 8) (unsigned-byte 16) (unsigned-byte 32)))
+      (signal 'type-error :datum element-type
+                          :expected-type '(or
+                                           (unsigned-byte 8)
+                                           (unsigned-byte 16)
+                                           (unsigned-byte 32))))
+    (let* ((bytes
+             (* length bytes-per-element))
+           (heap-pointer
+             (jss:new "com.sun.jna.Memory" bytes))
+           (bytebuffer
+             (#"getByteBuffer" heap-pointer 0 bytes))
+           (static-vector
+             (make-array length :element-type element-type :nio-buffer bytebuffer)))
+      (setf (gethash static-vector *static-vector-pointer*)
+            heap-pointer)
+      (values
+       static-vector
+       heap-pointer))))
+
 (defun make-shareable-byte-vector (size)
   "Create a Lisp vector of SIZE bytes can passed to
 WITH-POINTER-TO-VECTOR-DATA."
-  (make-array size :element-type '(unsigned-byte 8)))
+  (if (find :nio *features*)
+      (make-shareable-vector size :element-type '(unsigned-byte 8)) ;; abcl-1.6.2-dev, upcoming abcl-1.7.0
+      (make-array size :element-type '(unsigned-byte 8))))
 
 (let ((method (jmethod "com.sun.jna.Pointer"
                        (jna-setter :char) "long" (jna-setter-arg-type :char))))
@@ -314,13 +357,17 @@ WITH-POINTER-TO-VECTOR-DATA."
 
 (defmacro with-pointer-to-vector-data ((ptr-var vector) &body body)
   "Bind PTR-VAR to a foreign pointer to the data in VECTOR."
-  (let ((vector-sym (gensym "VECTOR")))
-    `(let ((,vector-sym ,vector))
-       (with-foreign-pointer (,ptr-var (length ,vector-sym))
-         (copy-to-foreign-vector ,vector-sym ,ptr-var)
-         (unwind-protect
-              (progn ,@body)
-           (copy-from-foreign-vector ,vector-sym ,ptr-var))))))
+  (let ((vector-sym (gensym "VECTOR"))
+        (heap-pointer (gethash vector *static-vector-pointer*)))
+    (if heap-pointer
+        `(let ((,ptr-var ,heap-pointer))
+           (progn ,@body))
+        `(let ((,vector-sym ,vector))
+           (with-foreign-pointer (,ptr-var (length ,vector-sym))
+             (copy-to-foreign-vector ,vector-sym ,ptr-var)
+             (unwind-protect
+                  (progn ,@body)
+               (copy-from-foreign-vector ,vector-sym ,ptr-var)))))))
 
 ;;;# Dereferencing
 
diff -pruN 1:0.22.1-2/src/libraries.lisp 1:0.23.0-1/src/libraries.lisp
--- 1:0.22.1-2/src/libraries.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/src/libraries.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -135,6 +135,7 @@
    (type :initform :system :initarg :type)
    (spec :initarg :spec)
    (options :initform nil :initarg :options)
+   (load-state :initform nil :initarg :load-state :accessor foreign-library-load-state)
    (handle :initform nil :initarg :handle :accessor foreign-library-handle)
    (pathname :initform nil)))
 
@@ -188,7 +189,7 @@
         finally (return (mapcar #'pathname search-path))))
 
 (defun foreign-library-loaded-p (lib)
-  (not (null (foreign-library-handle (get-foreign-library lib)))))
+  (not (null (foreign-library-load-state (get-foreign-library lib)))))
 
 (defun list-foreign-libraries (&key (loaded-only t) type)
   "Return a list of defined foreign libraries.
@@ -230,7 +231,7 @@ all libraries are returned."
           spec))
 
 (defmethod initialize-instance :after
-    ((lib foreign-library) &key search-path
+    ((lib foreign-library) &key canary search-path
      (cconv :cdecl cconv-p)
      (calling-convention cconv calling-convention-p)
      (convention calling-convention))
@@ -250,7 +251,8 @@ all libraries are returned."
                (when value (setf (getf options key) value))))
         (set-option :convention convention)
         (set-option :search-path
-                    (mapcar #'pathname (ensure-list search-path)))))))
+                    (mapcar #'pathname (ensure-list search-path)))
+        (set-option :canary canary)))))
 
 (defun register-foreign-library (name spec &rest options)
   (let ((old-handle
@@ -374,11 +376,17 @@ This will need to be extended as we test
 
 (defun %do-load-foreign-library (library search-path)
   (flet ((%do-load (lib name spec)
-           (when (foreign-library-spec lib)
-             (with-slots (handle pathname) lib
-               (setf (values handle pathname)
-                     (load-foreign-library-helper
-                      name spec (foreign-library-search-path lib)))))
+           (let ((canary (getf (foreign-library-options lib) :canary)))
+             (cond
+               ((and canary (foreign-symbol-pointer canary))
+                ;; Do nothing because the library is already loaded.
+                (setf (foreign-library-load-state lib) :static))
+               ((foreign-library-spec lib)
+                (with-slots (handle pathname) lib
+                  (setf (values handle pathname)
+                        (load-foreign-library-helper
+                         name spec (foreign-library-search-path lib)))
+                  (setf (foreign-library-load-state lib) :external)))))
            lib))
     (etypecase library
       (symbol
@@ -410,7 +418,10 @@ This will need to be extended as we test
   "Loads a foreign LIBRARY which can be a symbol denoting a library defined
 through DEFINE-FOREIGN-LIBRARY; a pathname or string in which case we try to
 load it directly first then search for it in *FOREIGN-LIBRARY-DIRECTORIES*;
-or finally list: either (:or lib1 lib2) or (:framework <framework-name>)."
+or finally list: either (:or lib1 lib2) or (:framework <framework-name>).
+The option :CANARY can specify a symbol that will be searched to detect if
+the library is already loaded, in which case DEFINE-FOREIGN-LIBRARY will mark
+the library as loaded and return."
   (let ((library (filter-pathname library)))
     (restart-case
         (progn
@@ -446,6 +457,8 @@ or finally list: either (:or lib1 lib2)
     (when handle
       (%close-foreign-library handle)
       (setf (foreign-library-handle lib) nil)
+      ;; Reset the load state only when the library was externally loaded.
+      (setf (foreign-library-load-state lib) nil)
       t)))
 
 (defun reload-foreign-libraries (&key (test #'foreign-library-loaded-p))
diff -pruN 1:0.22.1-2/src/package.lisp 1:0.23.0-1/src/package.lisp
--- 1:0.22.1-2/src/package.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/src/package.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -114,6 +114,7 @@
    #:*foreign-library-directories*
    #:*darwin-framework-directories*
    #:foreign-library
+   #:foreign-library-load-state
    #:foreign-library-name
    #:foreign-library-pathname
    #:foreign-library-type
diff -pruN 1:0.22.1-2/tests/defcfun.lisp 1:0.23.0-1/tests/defcfun.lisp
--- 1:0.22.1-2/tests/defcfun.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/tests/defcfun.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -314,20 +314,20 @@
 
 (deftest defcfun.varargs.float
     (with-foreign-pointer-as-string (s 100)
-      (sprintf s "%.2f" :float (float pi)))
-  "3.14")
+      (sprintf s "%.0f" :float (* pi 100)))
+  "314")
 
 (deftest defcfun.varargs.double
     (with-foreign-pointer-as-string (s 100)
-      (sprintf s "%.2f" :double (float pi 1.0d0)))
-  "3.14")
+      (sprintf s "%.0f" :double (* pi 100d0)))
+  "314")
 
 #+(and scl long-float)
 (deftest defcfun.varargs.long-double
     (with-foreign-pointer-as-string (s 100)
       (setf (mem-ref s :char) 0)
-      (sprintf s "%.2Lf" :long-double pi))
-  "3.14")
+      (sprintf s "%.0Lf" :long-double (* pi 100)))
+  "314")
 
 (deftest defcfun.varargs.string
     (with-foreign-pointer-as-string (s 100)
diff -pruN 1:0.22.1-2/tests/fsbv.lisp 1:0.23.0-1/tests/fsbv.lisp
--- 1:0.22.1-2/tests/fsbv.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/tests/fsbv.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -79,8 +79,8 @@
 (deftest fsbv.4
     (let ((ans (doublepairdouble '(pr (a 4 b 5) dbl 2.5d0))))
       (values (getf (getf ans 'pr) 'a)
-	      (getf (getf ans 'pr) 'b)
-	      (getf ans 'dbl)))
+              (getf (getf ans 'pr) 'b)
+              (getf ans 'dbl)))
   8
   10
   5.0d0)
diff -pruN 1:0.22.1-2/tests/funcall.lisp 1:0.23.0-1/tests/funcall.lisp
--- 1:0.22.1-2/tests/funcall.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/tests/funcall.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -148,16 +148,16 @@
     (with-foreign-pointer-as-string (s 100)
       (setf (mem-ref s :char) 0)
       (foreign-funcall-varargs
-       "sprintf" (:pointer s :string "%.2f") :double (coerce pi 'double-float) :int))
-  "3.14")
+       "sprintf" (:pointer s :string "%.0f") :double (* pi 100d0) :int))
+  "314")
 
 #+(and scl long-float)
 (deftest funcall.varargs.long-double
     (with-foreign-pointer-as-string (s 100)
       (setf (mem-ref s :char) 0)
       (foreign-funcall-varargs
-       "sprintf" :pointer s :string "%.2Lf" :long-double pi :int))
-  "3.14")
+       "sprintf" :pointer s :string "%.0Lf" :long-double (* pi 100) :int))
+  "314")
 
 (deftest funcall.varargs.string
     (with-foreign-pointer-as-string (s 100)
diff -pruN 1:0.22.1-2/tests/struct.lisp 1:0.23.0-1/tests/struct.lisp
--- 1:0.22.1-2/tests/struct.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/tests/struct.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -490,7 +490,7 @@
   (1 . 2)
   (3 . 4))
 
-(defcstruct (struct-pair-default-translate :class pair-default)
+(defcstruct (struct-pair-default-translate)
   (a :int)
   (b :int))
 
@@ -508,7 +508,7 @@
   1
   2)
 
-(defcstruct (struct-pair+double :class pair+double)
+(defcstruct (struct-pair+double)
   (pr (:struct struct-pair-default-translate))
   (dbl :double))
 
@@ -566,6 +566,7 @@
 (defcfun "pair_plus_one_sum" :int
   (p (:struct pair+1)))
 
+#+#:unused
 (defcfun "pair_plus_one_pointer_sum" :int
   (p (:pointer (:struct struct-pair+1))))
 
@@ -574,13 +575,12 @@
     (pair-plus-one-pointer-sum '((1 . 2) . 3))
   6)
 
-#+#:unimplemented
-(defcfun "make_pair_plus_one" (:struct pair+1)
+(defcfun "make_pair_plus_one" (:struct struct-pair+1)
   (a :int)
   (b :int)
   (c :int))
 
-(defcfun "alloc_pair_plus_one" struct-pair+1
+(defcfun "alloc_pair_plus_one" (:pointer (:struct struct-pair+1))
   (a :int)
   (b :int)
   (c :int))
@@ -591,38 +591,20 @@
     (alloc-pair-plus-one 1 2 3)
   ((1 . 2) . 3))
 
-#+#:unimplemented
 (defcfun "pair_sum" :int
-  (p (:struct pair)))
+  (p (:struct struct-pair)))
 
-#+#:unimplemented
-(defcfun "make_pair" (:struct pair)
+(defcfun "make_pair" (:struct struct-pair)
   (a :int)
   (b :int))
 
-#|| ; TODO: load cffi-libffi for these tests to work.
 (deftest struct-values.fn.1
-    (with-foreign-object (p '(:struct pair))
-      (with-foreign-slots ((a b) p (:struct pair))
-        (setf a -1 b 2)
-        (pair-sum p)))
+    (pair-sum '(-1 . 2))
   1)
 
 (deftest struct-values.fn.2
-    (pair-sum '(3 . 5))
-  8)
-
-(deftest struct-values.fn.3
-    (with-foreign-object (p '(:struct pair))
-      (make-pair 7 11 :result-pointer p)
-      (with-foreign-slots ((a b) p (:struct pair))
-        (cons a b)))
-  (7 . 11))
-
-(deftest struct-values.fn.4
     (make-pair 13 17)
   (13 . 17))
-||#
 
 (defcstruct single-byte-struct
   (a :uint8))
diff -pruN 1:0.22.1-2/tests/test-asdf.lisp 1:0.23.0-1/tests/test-asdf.lisp
--- 1:0.22.1-2/tests/test-asdf.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/tests/test-asdf.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -27,13 +27,13 @@
 
 (in-package #:cffi-tests)
 
-#.(when (cffi-toolchain::static-ops-enabled-p)
-    '(deftest test-static-program
+(when (cffi-toolchain::static-ops-enabled-p)
+  (deftest test-static-program
       (progn
         (asdf:operate :static-program-op :cffi-tests/example)
         (let ((program (asdf:output-file :static-program-op :cffi-tests/example)))
           (uiop:run-program `(,(native-namestring program) "1" "2 3") :output :lines)))
-      ("Arguments: 1 \"2 3\"" "hello, world!") nil 0))
+    ("Arguments: 1 \"2 3\"" "hello, world!") nil 0))
 
 (deftest test-asdf-load
     (progn
diff -pruN 1:0.22.1-2/toolchain/c-toolchain.lisp 1:0.23.0-1/toolchain/c-toolchain.lisp
--- 1:0.22.1-2/toolchain/c-toolchain.lisp	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/toolchain/c-toolchain.lisp	2020-07-08 11:38:29.000000000 +0000
@@ -116,7 +116,7 @@
        (setf (symbol-value sym)
              (if normalizep (normalize-flags linkset val) val))))
     (setf *ld* *cc*
-          *ld-exe-flags* `(,@*cc-flags* #-darwin "-Wl,--export-dynamic")
+          *ld-exe-flags* `(,@*cc-flags* #-(or sunos darwin) "-Wl,--export-dynamic")
           *ld-dll-flags* (list* #+darwin "-dynamiclib" ;; -bundle ?
                                 #-darwin "-shared"
                                 *cc-flags*))))
@@ -214,7 +214,7 @@
            #+freebsd (list "-I" "/usr/local/include/")
            (split-cflags (getenv "CFLAGS")))
           *ld* *cc*
-          *ld-exe-flags* `(,@arch-flags #-darwin "-Wl,--export-dynamic")
+          *ld-exe-flags* `(,@arch-flags #-(or sunos darwin) "-Wl,--export-dynamic")
           *ld-dll-flags* (list* #+darwin "-dynamiclib" ;; -bundle ?
                                 #-darwin "-shared"
                                 *cc-flags*)
@@ -254,9 +254,9 @@ is bound to a temporary file name, then
   (with-temporary-output (output-file)
     (apply 'invoke `(,@builder ,output-file ,@args))))
 
-(defun cc-compile (output-file inputs)
+(defun cc-compile (output-file inputs &optional cflags)
   (apply 'invoke-builder (list *cc* "-o") output-file
-         "-c" (append *cc-flags* #-windows '("-fPIC") inputs)))
+         "-c" (append *cc-flags* cflags #-windows '("-fPIC") inputs)))
 
 (defun link-executable (output-file inputs)
   (apply 'invoke-builder (list *ld* "-o") output-file
@@ -348,7 +348,7 @@ is bound to a temporary file name, then
         ((:dll :shared-library) (link-shared-library output inputs))))))
 
 (defclass c-file (source-file)
-  ((cflags :initarg :cflags :initform :default)
+  ((cflags :initarg :cflags :initform nil)
    (type :initform "c")))
 
 (defmethod output-files ((o compile-op) (c c-file))
@@ -363,7 +363,7 @@ is bound to a temporary file name, then
 (defmethod perform ((o compile-op) (c c-file))
   (let ((i (first (input-files o c))))
     (destructuring-bind (.o .so) (output-files o c)
-      (cc-compile .o (list i))
+      (cc-compile .o (list i) (slot-value c 'cflags))
       (link-shared-library .so (list .o)))))
 
 (defmethod perform ((o load-op) (c c-file))
@@ -373,8 +373,7 @@ is bound to a temporary file name, then
 (setf (find-class 'asdf::c-file) (find-class 'c-file))
 
 (defclass o-file (source-file)
-  ((cflags :initarg :cflags :initform :default)
-   (type :initform (bundle-pathname-type :object)))
+  ((type :initform (bundle-pathname-type :object)))
   (:documentation "class for pre-compile object components"))
 
 (defmethod output-files ((op compile-op) (c o-file))
diff -pruN 1:0.22.1-2/.travis.yml 1:0.23.0-1/.travis.yml
--- 1:0.22.1-2/.travis.yml	2020-05-12 17:45:04.000000000 +0000
+++ 1:0.23.0-1/.travis.yml	2020-07-08 11:38:29.000000000 +0000
@@ -1,11 +1,13 @@
+os: linux
+dist: bionic
+language: generic
+
 branches:
   only:
     - master
 
-language: lisp
-
 env:
-  matrix:
+  jobs:
     #- LISP=abcl
     #- LISP=allegro
     - LISP=sbcl
@@ -17,7 +19,7 @@ env:
     #- LISP=cmucl
     #- LISP=ecl
 
-matrix:
+jobs:
   allow_failures:
     - env: LISP=ccl32
     - env: LISP=sbcl32
@@ -35,5 +37,3 @@ script:
   - cl -e '(ql:quickload :cffi-tests)
            (when (cffi-tests:run-all-cffi-tests)
              (uiop:quit 1))'
-
-sudo: required
